<template>
  <div class="text-titulo q-pa-xs">{{ titulo }}</div>

  <q-card :flat="flat">
    <q-table
      dense
      flat
      bordered
      :rows="dataSet"
      :columns="columnas"
      row-key="uuid"
      hide-pagination
      :rows-per-page-options="[0]"
      :loading="loading"
    >
      <!--------------------------------------
            loading
          ---------------------------------------->
      <template v-slot:loading>
        <Loading showing />
      </template>

      <template v-slot:no-data>
        <div
          class="full-width row flex-center text-orange q-gutter-sm"
          v-if="!loading"
        >
          <q-icon size="2em" name="sentiment_dissatisfied" />
          <span> No existen experiencias registradas en la plataforma </span>
        </div>
      </template>

      <template v-slot:body-cell-experiencia="props">
        <q-td :props="props">
          <q-item dense>
            <q-item-section>
              <q-item-label>
                ({{ props.row.organismo_codigo }})
                {{ props.row.experiencia }}
              </q-item-label>
              <q-item-label caption lines="2">
                Fecha Cursada : {{ $filters.Date(props.row.fecha) }}
              </q-item-label>
              <q-item-label
                caption
                lines="3"
                v-if="props.row.fehaciente !== 'S'"
              >
                Origen : Evento Migrado
              </q-item-label>
              <q-item-label caption lines="3" v-if="props.row.libro_folio">
                Libro y Folio : {{ props.row.libro_folio }}
              </q-item-label>
            </q-item-section>
          </q-item>
        </q-td>
      </template>

      <template v-slot:body-cell-estado="props">
        <q-td :props="props">
          <EstadoExperiencia :estado="props.row.estado" />
        </q-td>
      </template>

      <template v-slot:body-cell-rama="props">
        <q-td :props="props">
          <ItemRama :rama="props.row.rama" :sinRama="false" />
        </q-td>
      </template>

      <template v-slot:body-cell-opciones="props">
        <q-td :props="props">
          <Download
            v-if="props.row.certificado"
            size="sm"
            :url="'/api/formacion/participantes/certificado/' + props.row.uuid"
            :nombre="
              formatExpDownload(
                props.row.fecha,
                props.row.organismo_codigo,
                props.row.experiencia
              )
            "
          >
            <i class="fas fa-file-pdf" />
            Certificado
          </Download>
        </q-td>
      </template>
    </q-table>
  </q-card>
</template>

<script lang="ts">
import { PropType, defineComponent, onMounted, ref } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import EstadoExperiencia from 'components/Formacion/EstadoExperiencia.vue';
import moment from 'moment';
import Download from 'components/Util/Download.vue';
import Loading from 'src/components/Loading.vue';
import ItemRama from 'src/components/Util/ItemRama.vue';

// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'experiencia', label: 'Experiencia', field: 'evento', align: 'left' },
  { name: 'estado', label: 'Estado', field: 'estado', align: 'center' },
  { name: 'rama', label: 'Rama', field: 'rama', align: 'center' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  name: 'ExperienciaDetalle',
  props: {
    uuid: {
      type: String as PropType<string>,
      require: true,
    },
    tipo: {
      type: String as PropType<string>,
      require: true,
    },
    titulo: {
      type: String as PropType<string>,
      require: true,
    },
    flat: {
      type: Boolean as PropType<boolean>,
      default: false,
      require: false,
    },
  },
  components: { Loading, EstadoExperiencia, Download, ItemRama },

  setup(props) {
    const loading = ref(true);
    const dataSet = ref([]);
    onMounted(() => {
      getExperiencias();
    });

    function getExperiencias() {
      api
        .get('/api/formacion/experiencias/' + props.uuid + '/' + props.tipo)
        .then((response: AxiosResponse) => {
          dataSet.value = response.data.data;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function formatExpDownload(
      fecha: string,
      organismo: string,
      nombre: string
    ) {
      let fecha2 = moment(fecha).format('YYYYMMDD');
      let nombre2 = nombre.replace(/ /g, '_').toLowerCase();
      return organismo + '_' + fecha2 + '_' + nombre2 + '.pdf';
    }

    return {
      loading,
      dataSet,
      columnas,
      ssss: props.titulo,
      formatExpDownload,
    };
  },
});
</script>
